/** TaskQueue.h: taskQueue skeleton function implementation
 *  @author C. Kessler 
 *  @date 990811
 */

#ifndef __TASKQUEUE_HEADER__
#define __TASKQUEUE_HEADER__

typedef PQueue TaskQueue;

/** The taskQueue skeleton function with its spawn macro:
 *  the implementation uses the parallel FIFO queue PQueue
 */
extern sync void taskQueue(
            sh sync void (*presetTaskQueue)( sh TaskQueue, sh void * ),
            sh void (*thetask)( TaskQueue, void * ),
            sh void *presetparam );

#define spawn( taskpool, task ) \
        PQueuePut( (PQueue)(taskpool), (void *)(task) )
           
/* implementation: see util/taskQueue.c */

#endif

